(defun format-to-lemma-analogy (name statement similarities)
  (with-temp-file (concat home-dir "lemmaanalogy.xml")
    (insert (format 
"
<similarities>
  <target-conjecture>
     <name>%s</name> 
     <statement>
%s
</statement>
  </target-conjecture>
  <source-conjectures>
  %s
  </source-conjectures>
</similarities>
"
name
(downcase (format "%s" statement))
(do ((temp similarities (cdr temp))
     (temp2 ""))
    ((endp temp) temp2)
  (setf temp2 (concat temp2 (format-source-conjecture (car temp)))))))))



(defun format-lemma (lemma)
  (format 
"
<lemma>
<name>%s</name>
<statement>
%s
</statement>
</lemma>
"
(car lemma) (downcase (format "%s" (cadr lemma)))))

(defun format-source-conjecture (lemma)
  (let ((uses (do ((temp (nth 1 (cadr lemma)) (cdr temp))
		   (temp2 ""))
		  ((endp temp) temp2)
		(setf temp2 (concat temp2 (format-lemma (car temp)))))))

  (format 
"
<source-conjecture>
 <name>%s</name>
 <statement>
%s
</statement>
 <relevance>1</relevance>
 <uses>%s</uses>
</source-conjecture>
"

(car lemma)
(downcase (format "%s" (caadr lemma)))
uses)))





;;;; Invoke lemma analogy

(defun invoke-lemma-analogy ()
  (shell-command  (concat  home-dir "lemmaanalogy/ml4acl2 " 
			    home-dir "lemmaanalogy.xml" " > " 
			    home-dir "output.xml"))
  (sleep-for 5)
  (let* ((file (read-lines (concat home-dir "output.xml")) )
	 (file1 (subseq file (search "uses" file)))
	 (statement0 (subseq file1 (search "<statement>" file1)))
	 (statement (subseq statement0 11 (search "</" statement0)))
	 )
    (with-current-buffer "*display*"
      (split-window-vertically)
      (switch-to-buffer-other-window "*display2*")
      (with-current-buffer "*display2*"
	(erase-buffer)
	(insert (format "Suggestions:\n"))
	(insert (format "------------------------------------------------------------------------------------------------\n"))
	(insert (remove-first-whitespaces (format "%s" statement)))
	(insert (format "\n------------------------------------------------------------------------------------------------\n"))))))

    


 
(defun remove-first-whitespaces (string)
  (let* ((temp string)
	 (pos1 (subseq temp 0 1))
	 (is-whitespace (string= pos1 " ")))
    (while is-whitespace 
      (setf temp (subseq temp 1))
      (setf pos1 (subseq temp 0 1))
      (setf is-whitespace (string= pos1 " ")))
    temp))

