(require 'cl)


(defun save-lemmas ()
  (with-temp-file (concat home-dir "lemmas.txt") (insert (format "%s" lemmas)))
  )




(defun print-list (list)
  (do ((temp list (cdr temp))
       (temp2 ""))
      ((endp temp) (subseq temp2 0 (1- (length temp2))))
    (setf temp2 (concat temp2 (format "%s;" (car temp))) )))


(defun last-part-of-lists (list)
  (do ((temp list (cdr temp))
       (temp2 nil))
      ((endp temp) temp2)
      (setf temp2 (append temp2 (list (cadar temp))))))

(defun print-lemmas-format ()
  (do ((temp (last-part-of-lists lemma-vectors) (cdr temp))
	 (temp2 ""))
	((endp temp) temp2)
    (setf temp2 (concat temp2 
			(format "%s\n"
				(print-list (car temp)))))))


(defun extract-features-to-file ()
  (interactive)
  (extract-recursive-beg-to-end)
  (convert-recursive)
  (with-temp-file (concat home-dir "output.csv") (insert (format "%s" (print-lemmas-format))))
  )


(defun add-libraryname-to-lemmas (name)
  (do ((temp lemmas (cdr temp))
       (temp2 nil))
      ((endp temp) temp2)
    (setf temp2 (append temp2 
			(list 
			 (append (list(car (read-from-string (format "%s::%s" name (caar temp)))))
			       (cdr (car temp))))))))



(defun add-libraryname-to-definitions (name)
  (do ((temp definitions (cdr temp))
       (temp2 nil))
      ((endp temp) temp2)
    (setf temp2 (append temp2 
			(list 
			 (append (list(car (read-from-string (format "%s::%s" name (caar temp)))))
			       (cdr (car temp))))))))


(defun add-libraryname-to-deps (name)
  (do ((temp lemma-dependencies (cdr temp))
       (temp2 nil))
      ((endp temp) temp2)
    (setf temp2 (append temp2 
			(list 
			 (append (list(car (read-from-string (format "%s::%s" name (caar temp)))))
			       (cdr (car temp)))))))
  )


(defun export-library ()
  (interactive)
  (setf lemmas nil)
  (setf lemmaanalogy? t)
  (extract-recursive-beg-to-end)
  (let* ((buf (buffer-name))
	 (name (if (search "." buf) (subseq buf 0 (search "." buf)) buf)))
    (with-temp-file (concat home-dir "/libs/" name) 
      (insert (format "%s" (add-libraryname-to-lemmas name))))
    (with-temp-file (concat home-dir "/definitions/" name) 
      (insert (format "%s" (add-libraryname-to-definitions name))))
    (with-temp-file (concat home-dir "/dependencies/" name) 
      (insert (format "%s" (add-libraryname-to-deps name))))
    
    )
  (setf lemmaanalogy? nil)
  t)



(defvar imported-libraries nil)


(defun import-library (name)
  (with-temp-buffer
  (insert-file-contents (concat home-dir "/libs/" name))
  (car (read-from-string (format "%s" (read (current-buffer)))))
  ))

(defun import-deps (name)
  (with-temp-buffer
  (insert-file-contents (concat home-dir "/dependencies/" name))
  (car (read-from-string (format "%s" (read (current-buffer)))))
  ))


(defun import-definitions (name)
  (with-temp-buffer
  (insert-file-contents (concat home-dir "/definitions/" name))
  (car (read-from-string (format "%s" (read (current-buffer)))))
  ))


(defun add-several-libraries ()
  (interactive)
  (setf lemmas-libraries lemmas)
  (setf definitions-libraries definitions)
  (do ((temp libs-menus (cdr temp)))
      ((endp temp) nil)
      (progn (setf lemmas-libraries (append lemmas-libraries (import-library (car temp))))
	     ;(setf definitions-libraries (append definitions-libraries
	;					 (import-definitions (car temp))))
	     (setf lemma-dependencies (append lemma-dependencies (import-deps (car temp))))
	     )))



(defun add-several-libraries-defs ()
  (interactive)
  (setf definitions-libraries definitions)
  (do ((temp libs-menus (cdr temp)))
      ((endp temp) nil)
    (setf definitions-libraries (append definitions-libraries
					(import-definitions (car temp))))))

